//==============================================================================
// Tools sidebar functions
//
// Functions to display and hide the left sidebar calendar and navigation tools
// and set and read a cookie which saves this state between pages
//
// Additional functionality included to display the "report tools" area - the
// report heading which contains elements like the report title
//
// Created: 08/26/04 by Ed Lucas, RDVO Inc.
//==============================================================================

var bToolsVisible = true;  //default: sidebar is visible
var bReportToolsVisible = false;	//default: hide report tools area
var bPrinting = false;

//functions to be executed before and after print or print preview call
//IE only
window.onbeforeprint = BeforePrint
window.onafterprint = AfterPrint

//==============================================================================
function BeforePrint() {
	bPrinting = true;
	
	document.getElementById('LeftSpacer').width = '1';
	document.getElementById('ReportToolsTop').style.width = '100%';
	document.getElementById('crumbTrail').style.width = '100%';
	
	if (document.getElementById('UserLogo') != null) {
		document.getElementById('UserLogo').style.left = '32';
	}
	if (document.getElementById('ReportTitleArea') != null) {
		document.getElementById('ReportTitleArea').style.left = '101';
		document.getElementById('ReportTitleArea').style.width = '100%';
	}
	/*
	if (document.getElementById('ReportTools') != null) {
		document.getElementById('ReportTools').style.display = 'none';
	}
	*/
}

//==============================================================================
function AfterPrint() {
	bPrinting = false;
	ShowHideToolsOnload();
}

//==============================================================================
function PortalOnload() {
	//should we render the report tools area?
	if (ReportTools()) {
		ShowReportTools();
	}

	//set initial display of tools sidebar	
	ShowHideToolsOnload();
}

//==============================================================================
function ReportTools() {
	//should we display the report tools area?
	//returns true if id=ReportTitleArea exists in report
	return (document.getElementById('ReportTitleArea') != null)
}

//==============================================================================
function ShowHideToolsOnload() {
	//set initial state of sidebar on page load
	if (bToolsVisible) {
		ShowTools();
	} else {
		HideTools();
	}
}

//==============================================================================
function ShowHideTools() {
	//toggle sidebar view
	if (bToolsVisible) {
		HideTools();
	} else {
		ShowTools();
	}
}

//==============================================================================
function ShowReportTools() {
	//display the report tools area
	if (document.getElementById('ReportTools') != null && !bPrinting) {
		document.getElementById('ReportTools').style.display = 'block';
		//document.getElementById('ReportTools').style.visibility = 'visible';
		bReportToolsVisible = true;
	}
}

//==============================================================================
function ShowTools() {
	//display the sidebar

	if (!bPrinting) {
		//make room for the tools sidebar
		document.getElementById('LeftSpacer').width = '139';
		document.getElementById('ReportToolsTop').style.width = '817';
		document.getElementById('crumbTrail').style.width = '370';

		//move the report tools
		if (bReportToolsVisible) {
			//document.getElementById('ReportTools').style.width = '798';
	
			if (document.getElementById('UserLogo') != null) {
				document.getElementById('UserLogo').style.left = '170';
			}
			if (document.getElementById('ReportTitleArea') != null) {
				document.getElementById('ReportTitleArea').style.left = '239';
				document.getElementById('ReportTitleArea').style.width = '410';
			}
		}
	}
	//display the tools
	document.getElementById('Tools').style.visibility='visible';
	
	//change the tab graphic
	document.getElementById('TabShowHide').src = '../Objectstore/Images/page_tab_hide_tools.gif';

	bToolsVisible = true;
	SetToolsCookie(bToolsVisible);
}

//==============================================================================
function HideTools() {
	//hide the sidebar
	
	//make the tools sidebar invisible
	document.getElementById('Tools').style.visibility='hidden';
	
	if (!bPrinting) {
		//expand the content area and collapse the tools sidebar
		document.getElementById('LeftSpacer').width = '1';
		document.getElementById('ReportToolsTop').style.width = '955';
		document.getElementById('crumbTrail').style.width = '500';
	
		//move the report tools
		if (bReportToolsVisible) {
			//document.getElementById('ReportTools').style.width = '936';
			
			if (document.getElementById('UserLogo') != null) {
				document.getElementById('UserLogo').style.left = '32';
			}
			if (document.getElementById('ReportTitleArea') != null) {
				document.getElementById('ReportTitleArea').style.left = '101';
				document.getElementById('ReportTitleArea').style.width = '540';
			}
		}
	}
	
	//change the tab graphic
	document.getElementById('TabShowHide').src = '../Objectstore/Images/page_tab_show_tools.gif';
	
	bToolsVisible = false;
	SetToolsCookie(bToolsVisible);
}

//==============================================================================
function SetToolsCookie(strValue) {
	//set the value of the tools cookie
	document.cookie = "tools=" + strValue + ";";
}

//==============================================================================
function GetToolsCookie() {
	//get the value of the tools cookie
	
	var strCookieValue = "";
	var strCookieName = "tools";
	var allCookies = document.cookie;
	var pos = allCookies.indexOf(strCookieName + "=");
	
	//if cookie exists
	if (pos != -1) {
		var start = pos + strCookieName.length + 1;
		var end = allCookies.indexOf(";", start);
		if (end == -1) end = allCookies.length;
		
		//get cookie value
		strCookieValue = allCookies.substring(start, end);
	}
	
	return strCookieValue;
}