Rem
Rem
Rem $Header:   /pvcs/db/products/archives/install/DataView/pvrscripts/DVOptimizerToDefault.sql-arc   1.1   09 Feb 2004 12:19:16   jchang  $
Rem
Rem Proviso MANAGER Release 4
Rem Copyright 1996-2003 Quallaby
Rem
Rem NAME
Rem    DVOptimizerToDefault.sql
Rem
Rem
Rem DESCRIPTION
Rem
Rem >>>---   Change the optimizer mode of the DV users to their default values   ---<<<
Rem
Rem HISTORY  (MM-DD-YYYY)
Rem    tjoh   06-13-2003  Creation
Rem    tjoh   09-02-2003  Modified for 4.1
Rem


Set Define   "&"
Set Verify   Off
Set FeedBack On
Set Termout On
Set Pages 0

Whenever SQLERROR Exit 1

Prompt ===========================================================
Prompt =                                                         =
Prompt = This script modifies the CLNT_PARAMETER table to        =
Prompt = change the optimizer mode of the DV users to their      =
Prompt = default values.  All DV users must log off and log      =
Prompt = back on for this change to take effect since the        =
Prompt = optimizer mode for these users is set in the database   =
Prompt = logon trigger                                           =
Prompt =                                                         =
Prompt ===========================================================
Prompt

Set FeedBack Off

Set ServerOutput On Size 1000000

Declare
  iParmCount PLS_Integer;
  vcParmName V$Parameter.Name%Type;
Begin

  vcParmName := 'optimizer_mode';

  For recClntType In ( Select Idx_Ind, Str_Name
                         From Clnt_Type
                        Where Str_Name In ('LOIS',
                                           'REPORT',
                                           'REPORTMASTER') )
  Loop

    Dbms_Output.Put_Line('Returning optimizer mode for the '||recClntType.Str_Name||' client to default');
    Dbms_Output.Put_Line( '-------------------------------------------------------------');

    If recClntType.Str_Name = 'LOIS' Then
      
      Select Count(*)
        Into iParmCount
        From Clnt_Parameter
       Where Str_Param_Name = vcParmName
         And Idx_Clnt_Type = recClntType.Idx_Ind;

      If iParmCount > 0 Then
        Update Clnt_Parameter 
           Set Str_Value = 'FIRST_ROWS'
         Where Str_Param_Name = vcParmName
           And Idx_Clnt_Type = recClntType.Idx_Ind;
      Else
        Insert Into Clnt_Parameter (Str_Param_Name, Idx_Clnt_Type, Str_Ora_User, Str_Value)
                            Values (vcParmName, recClntType.Idx_Ind, NULL, 'FIRST_ROWS');
      End If; 
    Else
      Delete 
        From Clnt_Parameter 
       Where Str_Param_Name = vcParmName
         And Idx_Clnt_Type = recClntType.Idx_Ind;
    End If;
  End Loop;


  Dbms_Output.Put_Line( 'Optimizer update successfully completed' );
  Dbms_Output.Put_Line( '-------------------------------------------------------------');

End;
/

Commit;

Set FeedBack On

Set Verify On

Rem ======================  End of DVOptimizerToDefault.sql  ======================
